package jp.chiheisen;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.HashSet;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class HtmlParser {
	/** BASE^Op^[ */
	private static final Pattern BASE_PATTERN = Pattern.compile("\\<base [^\\>]*?href=\"?([^\"\\s]+)", Pattern.CASE_INSENSITIVE);
	
	/** N̏op^[ */
	private static final Pattern[] LINK_PATTERN = {
		Pattern.compile("\\<a [^\\>]*?href=\"?(?!mailto:)(?!javascript:)([^\"\\s]+)", Pattern.CASE_INSENSITIVE),	// LINK
		Pattern.compile("\\<link [^\\>]*?href=\"?([^\"\\s]+)", Pattern.CASE_INSENSITIVE),	// CSS, RSS, etc...
		Pattern.compile("\\<script [^\\>]*?src=\"?([^\"\\s]+)", Pattern.CASE_INSENSITIVE),	// JavaScript
		Pattern.compile("\\<img [^\\>]*?src=\"?([^\"\\s]+)", Pattern.CASE_INSENSITIVE),	// JavaScript
	};
	
	public Set<URL> parseLink(URL url, InputStream in) throws IOException{
		BufferedReader reader = new BufferedReader(new InputStreamReader(in));
		
		URL base = url;
		Set<String> path = new HashSet<String>();
		
		String buf;
		while((buf = reader.readLine()) != null){
			Matcher baseMatcher = BASE_PATTERN.matcher(buf);
			while(baseMatcher.find()){
				base = new URL(url, baseMatcher.group(1));
			}
			
			for(Pattern pattern : LINK_PATTERN){
				Matcher matcher = pattern.matcher(buf);
				while(matcher.find()){
					path.add(matcher.group(1));
				}
			}
		}
		
		Set<URL> link = new HashSet<URL>(path.size());
		for(String str : path){
			link.add(new URL(base, str));
		}
		
		return link;
	}

	
}
