package jp.chiheisen;
import java.io.IOException;
import java.io.PrintStream;
import java.net.HttpURLConnection;
import java.net.Proxy;
import java.net.URL;


public class URLConnectionWorker implements Runnable{
	/** NGXgURL */
	private final URL url;
	/** vLVT[o */
	private final Proxy proxy;
	/** ʏo͐ */
	private final PrintStream print;
	
	public URLConnectionWorker(URL url, Proxy proxy, PrintStream print){
		if (url == null) {
			throw new NullPointerException("url");
		}
		if (proxy == null) {
			throw new NullPointerException("proxy");
		}
		if (print == null) {
			throw new NullPointerException("print");
		}
		
		this.url = url;
		this.proxy = proxy;
		this.print = print;
	}

	@Override
	public void run() {
		try{
			HttpURLConnection con = (HttpURLConnection)url.openConnection(proxy);
	        con.setInstanceFollowRedirects(false);
			con.connect();
	        
	        int responseCode = con.getResponseCode();
	        switch(responseCode){
	        case HttpURLConnection.HTTP_OK:
	        	print.println(responseCode + ": " + url.toString());
	        }
	        
		}catch(IOException e){
			System.err.println(url);
			e.printStackTrace();
		}
	}

}
